import logging
import traceback

from html import escape
from telegram import User

_logger = logging.getLogger(__name__)


def user_any_name(user: User) -> str:
    name = [user.first_name, user.last_name]
    name = list(filter(lambda s: s is not None, name))
    name = ' '.join(name).strip()

    if not name:
        name = user.username

    if not name:
        name = str(user.id)

    return name


def exc2text(e: Exception) -> str:
    tb = ''.join(traceback.format_tb(e.__traceback__))
    return f'{e.__class__.__name__}: ' + escape(str(e)) + "\n\n" + escape(tb)


class IgnoreMarkup:
    pass
